<?php
/**
 * 邀请码注册（测试版）
 *
 * @package InvitationCode
 * @author 晨曦啊
 * @version 0.0.1
 * @link https://cx-a.com
 *
 * 历史版本
 * version 0.0.1 at 2018-11-11
 * 邀请码注册
 *
 */

class InvitationCode_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     *
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
        Typecho_Plugin::factory('admin/register.php')->InvitationCodeInput = array('InvitationCode_Plugin', 'add_input');
        Typecho_Plugin::factory('Widget_Register')->register = array('InvitationCode_Plugin', 'render');
        return _t('开启成功！');
    }


    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     *
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}

    /**
     * 获取插件配置面板
     *
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form)
    {
        $open = new Typecho_Widget_Helper_Form_Element_Radio('open_cxa', array("on" => "开启", "off" => "关闭"), "on",
            _t('是否开启邀请码注册'), "请尝试进行评论测试，以免不同模板造成误判。");
        $form->addInput($open);

        $code = new Typecho_Widget_Helper_Form_Element_Textarea('code_cxa', NULL, "cxa.com",
            _t('邀请码'), _t('多条邀请码请用换行符隔开'));
        $form->addInput($code);
    }

    /**
     * 个人用户的配置面板
     *
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}

    /**
     * 插件实现方法
     *
     * @access public
     * @return void
     */
    public static function render($dataStruct)
    {
        $options = Typecho_Widget::widget('Widget_Options');
        $set = $options->plugin('InvitationCode');
        if($set->open_cxa == 'on'){
            $code=$_POST['code_cxa'];
            $code_arr = explode("\n", $set->code_cxa);
            if (empty($code)) {
                throw new Typecho_Widget_Exception('未填填写邀请码！');
            }
            if (empty($code_arr)) {
                throw new Typecho_Widget_Exception('系统未填设置邀请码！请在后台设置！');
            }
            foreach ($code_arr as $value) {
                if($code === $value){
                    return $dataStruct;
                }
            }
            throw new Typecho_Widget_Exception('邀请码错误！');
        }
        return $dataStruct;
    }

    public static function add_input(){
        $options = Typecho_Widget::widget('Widget_Options');
        $set = $options->plugin('InvitationCode');
        if($set->open_cxa == 'on'){
            echo '<p>
                <label for="code_cxa" class="sr-only">邀请码</label>
                <input type="text" id="code_cxa" name="code_cxa" placeholder="邀请码" value="" class="text-l w-100" />
            </p>';
        }
    }
}